<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML>
    <HEAD>
        <TITLE>DMT Loop Test via SeqInsert Documentation</TITLE>
    </HEAD>

    <BODY>
        <H1 align="center">How to run DMT Loop Test via SeqInsert</H1>

        <P>In an engineering run, the actual dmt triggers are sent via a ligotools program SeqInsert
		via an http like process. This test exercises the method to make sure ldas is compatible
		with actual dmt process; the test objectives are the same as simulated DMT:
		<UL>
		<LI>Ability of ldas to ingest data from external xml formatted by dmt process by retrieving xml from url,
		converting it into ilwd format and inserting the data into the database.</LI><p>
		
		<LI>Account for all the data sent to ldas from dmt: at times there maybe errors obtaining the file from url, or there
		maybe due foreign key errors if the data is not inserted in sequence.  To ensure data integrity some fine tuning maybe
		necessary for the test e.g extending http time out in the ligolwAPI when the system is very busy. </LI><p>
		
		<LI>Continuous run of dmt alongside other LDAS jobs simulates real time situation. 
		</UL>
		
		<P>The LDAS APIs affected by this test are:
		<UL>
		<LI><font color='blue'>managerAPI</font>: directs processing of the insertion user commands to the ligolwAPI and metadataAPI
			and returns the user command status to the user.</LI><p>
		<LI><font color='blue'>ligolwAPI</font>: 
			<UL>
			<LI>Retrieves the data to be ingested from the specified url to ilwd object and sends the ilwd
			to the metadataAPI for insertion.
			</UL><p>
		<LI><font color='blue'>metadataAPI</font>: 
			<UL>
			<LI>insert the metadata ilwd data from ligolwAPI into the specified database.</LI>
			</UL>
		</UL>
		
		
        <H2>Setup</H2>
        <P>Choose a directory to install the tests scripts.  
		<UL>
		The script files are:
        <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/rundmt.tcl?rev=HEAD;content-type=text%2Fplain'>rundmt.tcl</a></font>
        starter and monitor script; install this script in directory one level above the dmt files.</li>           
        <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/insertTrigsLoop.test?rev=HEAD;content-type=text%2Fplain'>insertTrigsLoop.test</a></font>
        - dmt driver script</li>
        directory of dmt files  - download
		<a href='http://www.ldas-sw.ligo.caltech.edu/packages/dmt-test.tar.gz'>sample dmt files</a>
		and untar and unzip the files into a subdiretory 'triggers2' 
		<pre><font color='blue'>mkdir triggers2; cd triggers2; tar xvzf dmt-test.tar.gz</font></pre>
		<font color='red'>Remove the tar ball (.gz file) from the directory since only xml files can be used.</font><p>
	 
		<font color='blue'>SeqInsert</font> - from ligotools<BR>
		</CODE></LI><p>
				
        <P><B>Note:</B> The above files should be installed on your local platform which should also have ligotools
		installed already. <p>
		To setup the environment for ligotools, login on a sun workstation and
		enter : <font color='blue'><pre>eval `/ligotools/bin/use_ligotools`</pre></font>
		Now cd to the scripts directory and run your test from this workstation.<CODE></CODE>.  
		</UL>
        <H2>Running the test</H2>
		The test should be run from your local platform, and run in directory one level above scripts directory.

		</font></pre>	
	
        <B>Usage:</B> <CODE>rundmt.tcl [options] >& rundmt.log & </CODE>

        <P><TABLE border=1 cellspacing=0 cellpadding=10>
            <TR>
                <TH><B>Option</B>
                <TH><B>Description</B>
            <TR>
                <TD valign=top><CODE>&lt;site&gt;</CODE>
                <TD>ldas site [ dev | test | lho | llo | mit ]<p>
					or &lt;mycomputer&gt;:10001
			<TR>
        </TABLE><p>
		
		<p>
		<H2>Test Verification:</H2>
		The test should be monitored initially to make sure data is flowing in a steady pace and that the insertions
		are successful impling that data is inserted in the correct sequence.<p>
		<OL>
		<LI><font color='magenta'>Monitoring dmt</font><p>
			All output from script SeqInsert is captured to stdout which can be redirected to a file at startup e.g. cit.log.<p>
			A putMetaData user command is generated for each of the dmt files and sent to the managerAPI. The insertions
			can be monitored via cmonClient for the number of jobs and  the database insertions for the specified database. </LI>
		<p>
		<LI><font color='magenta'>Analysis</font><p>
			When all the xmls are sent to LDAS, the logs can be extracted via cmonClient Log page; enter the 
			gpstime ranges recorded in insertTrigs.log for logs in managerAPI, ligolwAPI and metadataAPI.
			Validate the following is true for successful insertions:<p>
            
			<ul>
			<li>Number of files finish by SeqInsert should trail closely to number of jobs submitted.
				<pre> grep -c submit &lt; insertTrigs log file &gt; 
 grep -c finish &lt; insertTrigs log file &gt;  </pre></li>
			<li>Jobs statistics page should report the number sent by SeqInsert.</li><p>
			<li>Database statistics page should report the total number of insertions sent by SeqInsert.</li><p>
			<li>Number of gds_triggers inserted in database = number of gds_triggers in xml files <p>
				use guild query <p>
				<font color='blue'><pre>select count(*) from gds_trigger where process_id in 
(select process_id from process where program
in ('glitchMon', 'PSLmon','LockLoss','BitTest','SegGener'))</pre></font>
			to confirm this is the case.</li>
			<p>Other records inserted include process and segments. Also confirm this number in the database is the
			same as in xml files. <p>
			Expected number of insertions per round with the current set of dmt files:<p>
			<tt>	Number of process records		= 		9 ( 1 BitTest 2 glitchMon 1 LockLoss 3 PSLmon 2 SegGener )<p>
                    Number of gds_trigger records	=	34450<p>
	                Number of segments records		=	  489<p>
			</tt>	
			</ul>
			<p>Notes on SeqInsert:<p>
			<ol>
			<li>Check SeqInsert state by typing <font color='blue'>'SeqInsert check'</font>. Possible returns:<p>
			<pre>
                                <font color='green'>State is run</font>   or 
				<font color='green'>State is idle</font>  or 
				<font color='red'>State is error</font>
            </pre>
			If state is idle or error, examine the dmt log for errors; the test has to be restarted.</li><p>
            <li>To shutdown the test, type
            <pre><font color='blue'>SeqInsert shutdown & </pre></font>
            and kill off the tcl script.           	
            </ol>
			<p>If there is a discrepancy search the logs for <font color='red'>red</font> balls to account for missing records.
			<p>Also examine the ldas database web page for the number of processes, segments and
			gds_triggers inserted to make sure they match the expected number.
			
			<p>If all the process and trigger data are inserted, the test <font color='green'>passes</font>. 
			If not, the test <font color='red'>fails</font> and the errors in the logs should account for all data received at LDAS.
        
        </OL>	
    </BODY>
</HTML>

